
// This file contains inline implementations of the file NAMemory.h
// Do not include this file directly! It will automatically be included when
// including "NAMemory.h"



#include "NAMallocFreeII.h"
#include "NARefCountII.h"
#include "NAPtrII.h"
#include "NASmartPtrII.h"
#include "NAPointerII.h"
#include "NARuntimeII.h"

#if NA_IS_POSIX
#include <unistd.h>
#endif

// //////////////////////////////////////
// Accessing informations about the memory system
// //////////////////////////////////////


NA_IDEF size_t naGetSystemMemoryPagesize(){
  #if NA_OS == NA_OS_WINDOWS
    SYSTEM_INFO info;
    GetSystemInfo(&info);
    return (size_t)info.dwPageSize;
  #else
    return (size_t)sysconf(_SC_PAGESIZE);
  #endif
}



NA_IDEF size_t naGetSystemMemoryPagesizeMask(){
  return ~(naGetSystemMemoryPagesize() - 1);
}



// This is free and unencumbered software released into the public domain.

// Anyone is free to copy, modify, publish, use, compile, sell, or
// distribute this software, either in source code form or as a compiled
// binary, for any purpose, commercial or non-commercial, and by any
// means.

// In jurisdictions that recognize copyright laws, the author or authors
// of this software dedicate any and all copyright interest in the
// software to the public domain. We make this dedication for the benefit
// of the public at large and to the detriment of our heirs and
// successors. We intend this dedication to be an overt act of
// relinquishment in perpetuity of all present and future rights to this
// software under copyright law.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

// For more information, please refer to <http://unlicense.org/>
